Package: twilight
Version: 1.88.0
Title: Estimation of local false discovery rate
Authors@R: person(given="Stefanie",family="Senger",
  email="stefanie.scheid@gmx.de",role=c("cre","aut"),
  comment=c(ORCID="0000-0003-4144-1040"))
Description: In a typical microarray setting with gene expression data
        observed under two conditions, the local false discovery rate
        describes the probability that a gene is not differentially
        expressed between the two conditions given its corrresponding
        observed score or p-value level. The resulting curve of
        p-values versus local false discovery rate offers an insight
        into the twilight zone between clear differential and clear
        non-differential gene expression. Package 'twilight' contains
        two main functions: Function twilight.pval performs a
        two-condition test on differences in means for a given input
        matrix or expression set and computes permutation based
        p-values. Function twilight performs a stochastic downhill
        search to estimate local false discovery rates and effect size
        distributions. The package further provides means to filter for
        permutations that describe the null distribution correctly.
        Using filtered permutations, the influence of hidden
        confounders could be diminished.
Depends: R (>= 2.10)
Imports: Biobase, graphics, grDevices, splines, stats
Suggests: golubEsets (>= 1.4.2), vsn (>= 1.7.2)
License: GPL (>= 2)
URL: http://compdiag.molgen.mpg.de/software/twilight.shtml
biocViews: Microarray, DifferentialExpression, MultipleComparison
git_url: https://git.bioconductor.org/packages/twilight
git_branch: RELEASE_3_23
git_last_commit: 3b91675
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.23
Date/Publication: 2026-04-28
NeedsCompilation: yes
Packaged: 2026-04-29 01:17:52 UTC; biocbuild
Author: Stefanie Senger [cre, aut] (ORCID:
    <https://orcid.org/0000-0003-4144-1040>)
Maintainer: Stefanie Senger <stefanie.scheid@gmx.de>

plot.twilight <- function(x, which=NULL, grayscale=FALSE, legend=TRUE, ...){
### Plotting function for objects of class "twilight".
### Produces these plots:
###
### "scores": Expected vs. observed test statistics with
###          confidence lines. Points exceeding the confidence lines
###          are highlighted. Reference:
###          Tusher VG, Tibshirani R and Chu G (2001): Significance
###          analysis of mircroarrays applied to the ionizing response,
###          PNAS 98(9), pp. 5116-5121.
###
### "qvalues": q-values vs. number of rejected hypotheses.
###
### "fdr": p-values vs. 1 - local false discovery rate.
###          Bottom ticks are 1% quantiles of p-values.
###          If computed, with bootstrap estimate and bootstrap confidence interval.
###
### "volcano": Volcano plot: Observed scores vs. local false discovery rate.
###          Bottom ticks are 1% quantiles of scores.
###
### "effectsize": Effect size distribution in terms of fold change equivalent scores.
### "table": Tabulate effect size distribution.
###
### Additional input:
### "grayscale": TRUE or FALSE. FALSE produces colored plots.
### "legend":    TRUE or FALSE. Produces legends in "scores", "fdr" and "effectsize".


  funk0 <- function(yin,kol,leg,...){
    if (all(is.nan(yin$result$fdr[1]),na.rm=FALSE)){
      par(mfrow=c(1,2),mar=c(4,4,2,2)+0.1)
      funk1(x,kol,leg,...)
      funk2(x,...)      
    }
    else {
      par(mfrow=c(2,2),mar=c(4,4,2,2)+0.1)
      funk1(x,kol,leg,...)
      funk2(x,...)      
      funk3(x,kol,leg,...)
      funk4(x,...)
    }
  }


  
  funk1 <- function(yin,kol,leg,...){
    if (all(is.nan(yin$result$observed[1]),na.rm=FALSE)){
      stop("The input object must contain observed and expected test scores.\n Choose 'qvalues' or 'fdr' instead.\n")
    }

    maxi <- 2*abs(yin$result$observed[1])
    y <- abs(yin$result$observed[1])
        
    if (kol==TRUE){
      plot(yin$result$expected,yin$result$observed,xlab="Expected score",ylab="Observed score",type="n",xlim=c(-y,y),ylim=c(-y,y),...)
      lines(c(-maxi,maxi),c(-maxi,maxi))
      points(yin$result$expected[as.logical(!yin$result$candidate)],yin$result$observed[as.logical(!yin$result$candidate)])
      points(yin$result$expected[as.logical(yin$result$candidate)],yin$result$observed[as.logical(yin$result$candidate)],col=gray(0.5))
      lines(c(-maxi,maxi),c(-maxi-yin$ci.line,maxi-yin$ci.line),col=gray(0.5))
      lines(c(-maxi,maxi),c(-maxi+yin$ci.line,maxi+yin$ci.line),col=gray(0.5))      
      if (leg==TRUE){
        legend(0,-y*0.8,legend=paste(as.character(100*yin$quant.ci),"% CI",sep=""),lty=1,bty="n",col=gray(0.5))
      }
    }
    
    if (kol==FALSE){
      plot(yin$result$expected,yin$result$observed,xlab="Expected score",ylab="Observed score",type="n",xlim=c(-y,y),ylim=c(-y,y),...)
      lines(c(-maxi,maxi),c(-maxi,maxi),lwd=2)
      points(yin$result$expected[as.logical(!yin$result$candidate)],yin$result$observed[as.logical(!yin$result$candidate)])
      points(yin$result$expected[as.logical(yin$result$candidate)],yin$result$observed[as.logical(yin$result$candidate)],col="red")
      lines(c(-maxi,maxi),c(-maxi-yin$ci.line,maxi-yin$ci.line),col="red")
      lines(c(-maxi,maxi),c(-maxi+yin$ci.line,maxi+yin$ci.line),col="red")      
      if (leg==TRUE){
        legend(0,-y*0.8,legend=paste(as.character(100*yin$quant.ci),"% CI",sep=""),lty=1,bty="n",col="red")
      }
    }
  }





  funk2 <- function(yin,...){
    y        <- unique(yin$result$qvalue)
    hist.num <- hist(yin$result$qvalue,br=c(-1,y),plot=FALSE)$counts

    plot(c(0,y),cumsum(c(0,hist.num)),t="s",xlab="Q-value",ylab="No. of significant outcomes",...)
    lines(c(-10,10),c(0,0),col=gray(0.5))
  }






  funk3 <- function(yin,kol,leg,...){
    if (all(is.nan(yin$result$fdr[1]),na.rm=FALSE)){
      stop("The input object must contain local FDR values.\n Choose 'scores' or 'qvalues' instead or run twilight.\n")
    }

    q.tick <- quantile(yin$result$pvalue,seq(0,1,by=0.01))
    x <- round(seq(1,nrow(yin$result),length=100))
    
    if (kol==TRUE){
      plot(yin$result$pvalue[x],1-yin$result$fdr[x],t="n",xlab="P-value",ylab=expression("1-"~~widehat(fdr)),ylim=c(0,1),...)
      lines(c(-10,10),c(0,0),col=gray(0.5))
      if (is.nan(yin$result$mean.fdr[1])==FALSE){
        lines(yin$result$pvalue[x],1-yin$result$lower.fdr[x],col=gray(0.5),lty=2)
        lines(yin$result$pvalue[x],1-yin$result$upper.fdr[x],col=gray(0.5),lty=2)
        lines(yin$result$pvalue[x],1-yin$result$mean.fdr[x],col=gray(0.5))
        if (leg==TRUE){
          legend(0.6,1,legend=c(expression("1-"~~widehat(fdr)),"Mean",paste(as.character(100*yin$boot.ci),"% CI",sep="")),lty=c(1,1,2),bty="n",col=c("black",gray(0.5),gray(0.5)),lwd=c(2,1,1))
        }
      }
      lines(yin$result$pvalue[x],1-yin$result$fdr[x],lwd=2)
      rug(q.tick)
    }

    if (kol==FALSE){
      plot(yin$result$pvalue[x],1-yin$result$fdr[x],t="n",xlab="P-value",ylab=expression("1-"~~widehat(fdr)),ylim=c(0,1),...)
      lines(c(-10,10),c(0,0),col=gray(0.5))
      if (is.nan(yin$result$mean.fdr[1])==FALSE){
        lines(yin$result$pvalue[x],1-yin$result$lower.fdr[x],col="red",lty=2)
        lines(yin$result$pvalue[x],1-yin$result$upper.fdr[x],col="red",lty=2)
        lines(yin$result$pvalue[x],1-yin$result$mean.fdr[x],col="red")
        if (leg==TRUE){
          legend(0.6,1,legend=c(expression("1-"~~widehat(fdr)),"Mean",paste(as.character(100*yin$boot.ci),"% CI",sep="")),lty=c(1,1,2),bty="n",col=c("black","red","red"),lwd=c(2,1,1))
        }
      }
      lines(yin$result$pvalue[x],1-yin$result$fdr[x],lwd=2)
      rug(q.tick)
    }
  }





  funk4 <- function(yin,...){
    if (all(is.nan(yin$result$fdr[1]),na.rm=FALSE)){
      stop("The input object must contain local FDR values.\n Choose 'scores' or 'qvalues' instead or run twilight.\n")
    }

    q.tick <- quantile(yin$result$observed,seq(0,1,by=0.01))
    maxi   <- 2*max(abs(yin$result$observed))

    plot(yin$result$observed,1-yin$result$fdr,t="n",xlab="Observed test score",ylab=expression("1-"~~widehat(fdr)),ylim=c(0,1),...)
    lines(c(-maxi,maxi),c(0,0),col=gray(0.5))
    points(yin$result$observed,1-yin$result$fdr)
    rug(q.tick)
  }



  funk5 <- function(yin,leg,...){
    if (all(is.nan(yin$effect[[1]]),na.rm=FALSE)){
      stop("The input object must contain effect size frequencies.\n Choose 'scores' or 'qvalues' instead or run twilight.\n")
    }

    check <- unlist(strsplit(yin$call," "))
    if (check[2]!="fc."){
      stop("Effect size distributions can only be estimated with twilight.pval(.,method='fc').\n")
    }

    all <- hist(yin$result$observed,br=yin$effect$breaks,plot=FALSE)

    x.fc   <- yin$result$observed

    mini   <- ceiling(min(x.fc))
    maxi   <- floor(max(x.fc))
    x.tick <- seq(mini,maxi,length=abs(mini)+abs(maxi)+1)

    x.lab  <- (exp(abs(x.tick))-1)*100
    x.lab  <- paste(sign(x.tick)*round(x.lab),"%",sep="")

    plot(all,col=gray(0.7),xaxt="n",main="",xlab="Fold change equivalent score")
    plot(yin$effect,col="black",add=TRUE)

    if (leg==TRUE){
      legend(mean(x.tick[5:6]),max(all$counts),legend=c("Mixture","Alternative"),lty=c(1,1),bty="n",col=c(gray(0.7),"black"),lwd=c(2,2),y.intersp=2)
    }
      
    axis(1,at=x.tick,labels=x.lab)

  }






  funk6 <- function(yin){
    if (all(is.nan(yin$effect[[1]]),na.rm=FALSE)){
      stop("The input object must contain effect size frequencies.\n Choose 'scores' or 'qvalues' instead or run twilight.\n")
    }

    check <- unlist(strsplit(yin$call," "))
    if (check[2]!="fc."){
      stop("Effect size distributions can only be estimated with twilight.pval(.,method='fc').\n")
    }
    
    all <- hist(yin$result$observed,br=yin$effect$breaks,plot=FALSE)
    fce <- round((exp(abs(yin$effect$mids))-1)*100*sign(yin$effect$mids))
    tab <- cbind(yin$effect$mids,all$counts,yin$effect$counts)

    rownames(tab) <- paste(fce,"%",sep="")
    colnames(tab) <- c("LogRatio","Mixture","Alternative")
    
    return(tab)

  }

  


  if (is.null(which)){funk0(x,grayscale,legend,...)}
  else {
    switch(which,
           scores = funk1(x,grayscale,legend,...),
           qvalues = funk2(x,...),
           fdr = funk3(x,grayscale,legend,...),
           volcano = funk4(x,...),
           effectsize = funk5(x,legend,...),
           table = funk6(x)
           )
  }
  
}

print.twilight <- function(x, ...){

  cat("\n Twilight object with")
  cat("\n    ",nrow(x$result),"transcripts")
  cat("\n     observed and expected test statistics")
  cat("\n     p- and q-values")

  if (!is.nan(x$result$fdr[1])){
    cat("\n     local FDR")    
  }
  if (!is.nan(x$result$mean.fdr[1])){
    cat("\n     bootstrap estimates of local FDR")    
  }

  cat("\n")
  if (is.nan(x$boot.pi0[[1]])){
    cat("\n Estimated percentage of non-induced genes:\n")
    a <- x$pi0
    names(a) <- "pi0"
    print(a)
  }
  if (!is.nan(x$boot.pi0[[1]])){
    cat("\n Bootstrap estimate of percentage of non-induced")
    cat("\n genes with lower and upper ",x$boot.ci*100,"% CI:\n",sep="")
    print(x$boot.pi0)
  }
      
  cat("\n Function call:\n",x$call,"\n")
  if (!is.nan(x$lambda)){
    cat(" Function twilight used lambda =",x$lambda,"\n")
  }
}

### this script generates the example data sets
### (only for internal use)
### 19AUG2007: updated to "justvsn" but did not run code again.

rm(list=ls())
library(twilight)

### Leukemia data set of Golub et al. (1999)
library(golubEsets)
data(Golub_Merge)

### Variance-stabilizing normalization of Huber et al. (2002)
library(vsn)
golubNorm <- justvsn(Golub_Merge)

### A vector of class labels.
id <- as.numeric(Golub_Merge$ALL.AML)

expval <- twilight.pval(golubNorm,id)
save(expval,file="../../data/expval.rda")

exfdr <- twilight(expval,B=1000)
save(exfdr,file="../../data/exfdr.rda")

twilight.teststat <- function(xin,yin,method="fc",paired=FALSE,s0=NULL){
  ### extract data matrix if class(xin) is an expression set
  xin <- twilight.getmatrix(xin)

  ### check dimensions
  if (!is.matrix(xin)){
    stop("First input must be a matrix. \n")
  }

  if (!is.vector(yin)){
    stop("Second input must be a vector. \n")
  }

  if (length(yin)!=dim(xin)[2]){
    if (length(yin)!=dim(xin)[1]){
      stop("Dimensions of input matrix and length of index vector do not match. \n")
    }    
    xin <- t(xin)
  }

  if (length(yin)!=dim(xin)[2]){
    if (length(yin)!=dim(xin)[1]){
      stop("Dimensions of input matrix and length of index vector do not match. \n")
    }    
  }

  if ((method!="pearson")&(method!="spearman")){
  ### translate index vector yin into binary vector with 1 as case and 0 as control samples.
    y <- sort(unique(yin),na.last=TRUE)
    
    if (length(y)!=2){
      stop("Samples must belong to TWO classes. \n")
    }
    
    y1 <- which(yin==y[1])
    y2 <- which(yin==y[2])
    yin[y1] <- 0
    yin[y2] <- 1
    
    if (paired){
      if (sum(yin)!=sum(1-yin)){
        stop("This is a PAIRED twosample test. The sizes of the two classes must be equal. \n")
      }
    }
  }

  ### transform to ranks for Spearman coefficient.
  if (method=="spearman"){
    yin <- rank(yin)
    xin <- t(apply(xin,1,rank))
  }  

  
  ### Z test with s0=0 is a t test.
  if (!is.null(s0)){
    if((s0==0)&(method=="z")){method <- "t"}
  }
  
  if (is.null(s0)){s0 <- 0}


  if ((method!="pearson")&(method!="spearman")){
    funk1 <- function(a, b, c, d, s) {
      x <- .C(ifelse(paired,"paired","unpaired"), 
              as.integer(a),
              as.integer(sum(a)),
              as.integer(sum(1 - a)),       
              as.double(t(b)),
              as.integer(nrow(b)),
              as.integer(ncol(b)),
              as.integer(c), 
              as.integer(which(d == 1) - 1),
              as.integer(which(d == 0) - 1),
              as.double(s),
              e = double(nrow(b)),
              fudge = double(1), PACKAGE = "twilight")
      return(list(e=x$e,fudge=x$fudge))      
    }
    
    stat.obs <- switch(method,
                       t = funk1(yin,xin,1,yin,s0),
                       z = funk1(yin,xin,2,yin,s0),
                       fc = funk1(yin,xin,3,yin,s0)
                       )
    s0 <- stat.obs$fudge
    stat.obs <- stat.obs$e
  }
  
  if ((method=="pearson")|(method=="spearman")){
    funk2 <- function(a,b){
      .C("corsingle",
         as.double(a),
         as.double(t(b)),
         as.integer(nrow(b)),
         as.integer(ncol(b)),
         e=double(nrow(b)),PACKAGE="twilight")$e
    }
    
    stat.obs <- funk2(yin,xin)
  }


  return(list(observed=stat.obs,s0=s0))
}

twilight.getmatrix <- function(xin){
  ## Extracts the data matrix from an expression set.
  if (class(xin)[1]=="ExpressionSet"){
    xout <- exprs(xin)
    rownames(xout) <- featureNames(xin)
    colnames(xout) <- sampleNames(xin)
    result <- xout
  } 
  else {
	result <- xin
  }
  return(result)
}

twilight.permute.pair <- function(v,m,bal=TRUE){
### do "m" permutations of the vector "v" containing paired group labels.

  x <- sort(unique(v))
  
  if (bal==FALSE){
    M <- matrix(NA,m,length(v))
    M[1,] <- v
    for (i in 2:m){
      r <- runif(length(v)/2)
      s <- numeric(length(v))
      r <- round(r)
      s[v==x[1]] <- r
      s[v==x[2]] <- 1-r
      M[i,] <- s
    }
  }

  if (bal==TRUE){
    M <- matrix(NA,m,length(v))
    M[1,] <- v
    for (i in 2:m){
      n <- ceiling(length(v)/4)
      r <- runif(n)
      r <- round(r)
      r <- c(r,(1-r)[1:(length(v)/2-n)])
      s <- numeric(length(v))
      s[v==x[1]] <- r
      s[v==x[2]] <- 1-r      
      M[i,] <- s
    }
  }

  return(M)
}

twilight.filtering <- function(xin,yin,method="fc",paired=FALSE,s0=0,verbose=TRUE,num.perm=1000,num.take=50){


  ### extract data matrix if class(xin) is an expression set
  xin <- twilight.getmatrix(xin)

  ### check dimensions
  if (is.matrix(xin)==FALSE){
    stop("First input must be a matrix. \n")
  }

  if (is.vector(yin)==FALSE){
    stop("Second input must be a vector. \n")
  }

  if (length(yin)!=dim(xin)[2]){
    if (length(yin)!=dim(xin)[1]){
      stop("Dimensions of input matrix and length of index vector do not match. \n")
    }    
    xin <- t(xin)
  }

  if (length(yin)!=dim(xin)[2]){
    if (length(yin)!=dim(xin)[1]){
      stop("Dimensions of input matrix and length of index vector do not match. \n")
    }    
  }

  if ((method!="pearson")&(method!="spearman")){
  ### translate index vector yin into binary vector with 1 as case and 0 as control samples.
    y <- sort(unique(yin),na.last=TRUE)
    
    if (length(y)!=2){
      stop("Samples must belong to TWO classes. \n")
    }
    
    y1 <- which(yin==y[1])
    y2 <- which(yin==y[2])
    yin[y1] <- 0
    yin[y2] <- 1
    
    if (paired==TRUE){
      if (sum(yin)!=sum(1-yin)){
        stop("This is a PAIRED twosample test. \n")
      }
    }
  }

  ### transform to ranks for Spearman coefficient.
  if (method=="spearman"){
    yin <- rank(yin)
    xin <- t(apply(xin,1,rank))
  }  

  ### compute fudge factor for z-test.
  if (s0==0){
    if (method=="z"){
      s0 <- twilight.teststat(xin,yin,method="z",paired=paired)$s0
    }
  }

  ### run length check for iteration
  if ((num.perm/num.take > 50)&(verbose)){
    cat("The filtering might take some time. Consider to increase the stepsize 'num.take'. \n")
  }


  ### translate methods into numerical values
  if (method=="t"){meth=1}
  if (method=="z"){meth=2}
  if (method=="fc"){meth=3}
  if (method=="pearson"){meth=4}
  if (method=="spearman"){meth=4}

  
  ### remove non-unique permutations
  simplify <- function(a){    
    comp <- function(x,y,Z){
      funk <- function(i,a,b,C){(identical(C[a[i],],C[b[i],]))|(identical(C[a[i],],1-C[b[i],]))}
      sapply(seq(along=x),funk,x,y,Z)
    }    
    x <- outer(1:nrow(a),1:nrow(a),comp,a)
    diag(x) <- FALSE
    i <- 1
    while (sum(x[upper.tri(x)])>0){
      a <- a[!x[i,],]
      x <- x[!x[i,],!x[i,]]
      i <- i+1
    }    
    return(a)
  }

  
  ### compute test statistics, pooled p-values and KS statistics at once
  if (paired){
    perm <- function(a,x,y){
      b <- twilight.permute.pair(a,max(y,100),bal=FALSE)
      b <- rbind(b,x)
      b <- simplify(b)
      b <- b[-1,]
      return(b)
    }
    
    funk <- function(a,b,c,orig,s,verbose){
      if (verbose){cat(".")}
      .C("pairedKSTEST",
         as.integer(t(a)),
         as.integer(nrow(a)),
         as.integer(sum(a[1,])),
         as.integer(sum(1-a[1,])),
         as.double(t(b)),
         as.integer(nrow(b)),
         as.integer(ncol(b)),
         as.integer(c),
         as.integer(which(orig==1)-1),
         as.integer(which(orig==0)-1),
         as.double(s),
         f=double(nrow(a)),PACKAGE="twilight"
         )$f
    }
  }
  if (!paired){
    perm <- function(a,x,y){
      b <- twilight.permute.unpair(a,max(y,500),bal=FALSE)
      b <- rbind(b,x)
      b <- simplify(b)
      b <- b[-1,]
      return(b)
    }

    funk <- function(a,b,c,orig,s,verbose){
      if (verbose){cat(".")}
      .C("unpairedKSTEST",
         as.integer(t(a)),
         as.integer(nrow(a)),
         as.integer(sum(a[1,])),
         as.integer(sum(1-a[1,])),
         as.double(t(b)),
         as.integer(nrow(b)),
         as.integer(ncol(b)),
         as.integer(c),
         as.double(s),
         f=double(nrow(a)),PACKAGE="twilight"
         )$f
    }
  }
  if (meth==4){
    perm <- function(a,x,y){
      b <- twilight.permute.unpair(a,max(y,500),bal=FALSE)
      b <- rbind(b,x)
      b <- simplify(b)
      b <- b[-1,]
      return(b)
    }

    funk <- function(a,b,c,orig,s,verbose){
      if (verbose){cat(".")}
      .C("correlationKSTEST",
         as.double(t(a)),
         as.integer(nrow(a)),
         as.double(t(b)),
         as.integer(nrow(b)),
         as.integer(ncol(b)),
         f=double(nrow(a)),PACKAGE="twilight"
         )$f
    }
  }


  ### Expected frequencies of Hamming distances
  hamming.exp <- function(x,paired=TRUE){
    if (!paired){
      ham <- seq(0,min(sum(x),sum(1-x)))
      y <- choose(sum(x),ham)*choose(sum(1-x),ham)
    }
    if (paired){
      ham <- seq(0,floor(sum(x)/2))
      y <- choose(sum(x),ham)
      if (sum(x)%%2==0){
        y[length(y)] <- y[length(y)]/2
      }
    }
    y <- y/sum(y)
    names(y) <- ham*2
    return(y)  
  }

  ### Observed table of Hamming distances
  hamming.obs <- function(a,x,paired=TRUE){
    hamming.dist <- function(w,v){ # contributed by F. Markowetz
      u <- table(w,v)
      u <- u[1,2]+u[2,1]
      return(u)
    }

    if (!paired){
      ham <- seq(0,min(sum(x),sum(1-x)))*2
    }
    if (paired){
      ham <- seq(0,floor(sum(x)/2))*2
    }
    d <- apply(a,1,hamming.dist,v=x)
    d <- table(d)
    y <- numeric(length(ham))
    names(y) <- ham
    y[names(d)] <- d
    return(y)
  }
  

  

  
  ### start the filtering

  if (verbose){cat(paste("Filtering: Wait for",ceiling(num.perm/num.take),"to",round(num.perm/num.take)+10,"dots "))}
  id.perm <- perm(yin,NULL,num.take)
  ks <- funk(id.perm,xin,meth,yin,s0,verbose)
  a <- sort(ks,index.return=TRUE)  
  if (num.take==1){id.opt <- id.perm[a$ix[1:2],]}
  if (num.take>1){id.opt <- id.perm[a$ix[1:min(num.take,length(ks))],]}

  j <- 2
  
  repeat {
    id.perm <- perm(yin,id.opt,num.take)
    ks <- funk(id.perm,xin,meth,yin,s0,verbose)
    a <- sort(ks,index.return=TRUE)  
    b <- a$ix[1:min(j*num.take,length(ks))]
    id.opt <- id.perm[b,]
    ks <- ks[b]
    j <- j+1
    
    if (nrow(id.opt)>=num.perm){break}
    if (j>ceiling(num.perm/num.take)+10){
      warning("Filtering stopped. Number of filtered permutations will be lower than intended.")
      break
    }
  }
  if (verbose){cat("done\n")}

  ### first row contains original labeling but give back exactly B permutations.
  yperm <- rbind(yin,id.opt[-1,])

  ### do a goodness-of-fit chi^2-test to see if at least the distribution of Hamming distances of the filtered permutations to the original labeling is random.
  #a <- hamming.exp(yin,paired=paired)
  #b <- hamming.obs(id.opt,yin,paired=paired)

  ### concatenate small entries at both ends of the distributions.
  #a <- round(a*sum(b))

  #for (i in 1:2){
  #  x <- which(a>=10)[1]-1
  #  a[x] <- sum(a[1:x])
  #  a <- a[-(1:(x-1))]
  #  a <- rev(a)
  #  b[x] <- sum(b[1:x])
  #  b <- b[-(1:(x-1))]
  #  b <- rev(b)
  #}
                   
  #test <- suppressWarnings(chisq.test(x=b,p=a,rescale.p=TRUE)$p.value)
  
  return(yperm)
}

twilight.combi <- function(xin,pin,bin){
### Function gives all possible permutations of binary vector
### "xin".
###
### INPUT
###
### "xin": Binary vector of class labels.
### "pin": TRUE or FALSE. Are the samples paired or not?
### "bin": TRUE or FALSE. Should the permutations be balanced or 
###        unbalanced?
###
### OUTPUT
###
### "xout": Matrix of permuted class label vector. Each row contains
###         one permutation. If the sample size exceeds certain values,
###         "NULL" is returned.

  vec.runs <- function(x){
    y <- 1
    for (i in 2:length(x)){
      if (x[i]!=x[i-1]){
        y <- c(y,i)
      }
    }
    return(y)
  }
  
  mat.runs <- function(x){
    y <- 1
    for (i in 2:dim(x)[1]){
      if (sum(x[i,]!=x[i-1,])>0){
        y <- c(y,i)
      }
    }
    return(y)
  }
  
  pos <- function(x){
    if (x<0){x <- 0}
    return(x)
  }
  
  unpair.unbal <- function(xin){
    
    n1 <- sum(xin)
    n0 <- sum(1-xin)
    n  <- n0+n1
    m  <- choose(n,n0)
    
    A     <- matrix(NA,m,n)
    b     <- c(m*n0/n,m*n1/n)
    A[,1] <- rep(c(0,1),b)
    
    for (i in 2:n){
      r <- vec.runs(A[,1])
      if (i>2){r <- mat.runs(A[,1:(i-1)])}
      s1 <- rowSums(A[r,],na.rm=TRUE)			
      s0 <- rowSums((1-A[r,]),na.rm=TRUE)			
      
      b.new <- numeric()
      for (j in 1:length(r)){
        b.new <- c(b.new,b[j]*pos(n0-s0[j])/(n-i+1),b[j]*pos(n1-s1[j])/(n-i+1))
      }
      
      A[,i] <- rep(rep(c(0,1),length(b.new)/2),b.new)
      b <- b.new[b.new>0]
    }
    
    
    return(A)
  }
  
  unpair.bal <- function(xin){
    
    n1 <- sum(xin)
    n0 <- sum(1-xin)
    n  <- n0+n1
    
    if (n0<=n1){
      m.ceil  <- choose(n0,ceiling(n0/2))*choose(n1,floor(n0/2))      
      m.floor <- choose(n0,floor(n0/2))*choose(n1,ceiling(n0/2))
      
      if (n0%%2==0){A <- matrix(NA,m.ceil,n)}
      if (n0%%2!=0){A <- matrix(NA,m.ceil+m.floor,n)}
      
      A1 <- unpair.unbal(rep(c(0,1),c(ceiling(n0/2),floor(n0/2))))
      A2 <- unpair.unbal(rep(c(0,1),c(floor(n0/2),n1-floor(n0/2))))
      
      b1 <- rep(1:dim(A1)[1],rep(dim(A2)[1],m.ceil/dim(A2)[1]))
      b2 <- rep(1:dim(A2)[1],dim(A1)[1])
      
      for (i in 1:m.ceil){
        A[i,] <- c(A1[b1[i],],A2[b2[i],])
      }
      
      if (n0%%2!=0){
        A1 <- unpair.unbal(rep(c(0,1),c(floor(n0/2),ceiling(n0/2))))
        A2 <- unpair.unbal(rep(c(0,1),c(ceiling(n0/2),n1-ceiling(n0/2))))
        
        b1 <- rep(1:dim(A1)[1],rep(dim(A2)[1],m.floor/dim(A2)[1]))
        b2 <- rep(1:dim(A2)[1],dim(A1)[1])
        
        for (i in 1:m.floor){
          A[m.ceil+i,] <- c(A1[b1[i],],A2[b2[i],])
        }
      }
    }
        
    if (n1<n0){
      m.ceil  <- choose(n1,ceiling(n1/2))*choose(n0,floor(n1/2))
      m.floor <- choose(n1,floor(n1/2))*choose(n0,ceiling(n1/2))
      
      if (n1%%2==0){A <- matrix(NA,m.ceil,n)}
      if (n1%%2!=0){A <- matrix(NA,m.ceil+m.floor,n)}
      
      A1 <- unpair.unbal(rep(c(0,1),c(n0-floor(n1/2),floor(n1/2))))
      A2 <- unpair.unbal(rep(c(0,1),c(floor(n1/2),ceiling(n1/2))))
      
      b1 <- rep(1:dim(A1)[1],rep(dim(A2)[1],m.ceil/dim(A2)[1]))
      b2 <- rep(1:dim(A2)[1],dim(A1)[1])
      
      for (i in 1:m.ceil){
        A[i,] <- c(A1[b1[i],],A2[b2[i],])
      }
      
      if (n1%%2!=0){
        A1 <- unpair.unbal(rep(c(0,1),c(n0-ceiling(n1/2),ceiling(n1/2))))
        A2 <- unpair.unbal(rep(c(0,1),c(ceiling(n1/2),floor(n1/2))))
        
        b1 <- rep(1:dim(A1)[1],rep(dim(A2)[1],m.floor/dim(A2)[1]))
        b2 <- rep(1:dim(A2)[1],dim(A1)[1])
        
        for (i in 1:m.floor){
          A[m.ceil+i,] <- c(A1[b1[i],],A2[b2[i],])
        }
      }
    }
    
    return(A)
  }
  
  pair.unbal <- function(xin){
    
    n <- sum(xin)
    m <- 2^(n-1)
    A <- matrix(NA,m,2*n)
    
    b2 <- numeric()
    for (i in 1:floor(n/2)){
      b1 <- rep(c(0,1),c(n-i,i))
      b2 <- rbind(b2,unpair.unbal(b1))    
    }
    
    A[1,] <- sort(xin)
    for (i in 2:m){
      A[i,] <- c(b2[i-1,],1-b2[i-1,])
    }
    
    return(A)
  }
  
  pair.bal <- function(xin){
    
    n <- sum(xin)
    
    m.floor <- choose(n,floor(n/2))/2
    m.ceil  <- choose(n,ceiling(n/2))/2
    
    if (n%%2==0){m <- m.floor}
    if (n%%2!=0){m <- m.floor+m.ceil}
    
    A <- matrix(NA,m,2*n)
    
    b1 <- rep(c(0,1),c(n-floor(n/2),floor(n/2)))
    b2 <- unpair.unbal(b1)
    b2 <- b2[1:(dim(b2)[1]/2),]
    
    if (n%%2!=0){
      b1 <- rep(c(0,1),c(n-ceiling(n/2),ceiling(n/2)))
      b2 <- rbind(b2,unpair.unbal(b1))
    }
    
    for (i in 1:m){
      A[i,] <- c(b2[i,],1-b2[i,])
    }
    
    return(A)
  }



  n1 <- sum(xin)
  n0 <- sum(1-xin)
  n  <- n1+n0

  if (n>170){
    xout <- NULL
  }

  if (n<=170){
    if (pin==FALSE){
      if (bin==FALSE){
        xout <- NULL
        m <- choose(n,n0)
        if (m<=10000){
          xout <- unpair.unbal(xin)
          
          if (n0==n1){
            xout <- xout[-dim(xout)[1],]
          }
        }
      }
      if (bin==TRUE){
        xout <- NULL
        
        n.min <- min(n0,n1)
        n.max <- max(n0,n1)
        m <- choose(n.min,floor(n.min/2))*choose(n.max,floor(n.min/2))
        if (n.min%%2!=0){m <- m + choose(n.min,ceiling(n.min/2))*choose(n.max,ceiling(n.min/2))}
        
        if (m<=10000){
          xout <- unpair.bal(xin)
        }
      }
    }
    
    if (pin==TRUE){

      if (n0!=n1){
        stop("The input vector is not paired.")
      }
      
      n <- n/2
      
      if (bin==FALSE){
        xout <- NULL
        m <- 2^(n-1)
        if (m<=10000){
          xout <- pair.unbal(xin)
        }
      }
      if (bin==TRUE){
        xout <- NULL
        m.floor <- choose(n,floor(n/2))/2
        m.ceil  <- choose(n,ceiling(n/2))/2
        
        m <- m.floor
        if (n%%2!=0){m <- m+m.ceil}
        if (m<=10000){
          xout <- pair.bal(xin)
        }
      }
    }
  }
  
  ix <- rank(xin,ties.method="first")
  xout <- xout[,ix]

  if (bin==TRUE){
    xout <- rbind(xin,xout)
    rownames(xout) <- NULL
  }
  
  return(xout)
}

twilight.getlambda <- function(xin,verbose=TRUE){
### Function finds suitable regularization parameter "lambda". 
### For a sequence of lambdas, the objective function of SEP is
### computed for subsamples of the p-value vector "xin". 
### The final estimate is chosen based upon a Wilcoxon test
### comparison between objective function values of lambda=0 and
### each lambda>0. The penalized objective function should not
### differ a lot from the unpenalized one. Therefore, the 
### highest lambda that leads to a non-significant difference
### in means is chosen.

  ### Calling SEP.
  funk <- function(a,b){
    x   <- .C("sep",
              as.double(a),
              as.integer(length(a)),
              as.double(b),
              e = integer(length(a)),
              f = double(1),
              PACKAGE="twilight"
              )$f
    return(x)
  }

  ### Try some values.
  lam <- seq(0,0.05,by=0.005)
  n    <- min(1000,length(xin))
  
  boot.p <- matrix(NA,n,50)
  for (i in 1:50){
    boot.p[,i] <- sort(sample(xin,n,replace=TRUE))
  }

  obj0 <- apply(boot.p,2,funk,0)

  if (verbose){
    cat("Wait for some dots. \n")
  }

  res <- NULL
  for (j in 2:length(lam)){
    
    obj.fun <- apply(boot.p,2,funk,lam[j])    
    obj.fun <- obj.fun - obj0
    wilc <- suppressWarnings(wilcox.test(x=obj.fun,mu=0)$p.value)

    ### Look for non-significant differences.
    if (wilc<=0.05){
      res <- lam[j-1]
      break;
    }
        
    if (verbose){cat(".")}
  }
  if (verbose){cat("\n")}

  if (is.null(res)){res <- lam[length(lam)]}
  return(res) 
}

twilight <- function(xin,lambda=NULL,B=0,boot.ci=0.95,clus=NULL,verbose=TRUE){
### Function computes local false discovery rates for vector of p-values.
###
### INPUT
###
### "xin":      Vector of p-values or object of class "twilight".
### "lambda":   Regularization paramater. If not specified, function
###             "twilight.getlambda" is called.
### "B":        Number of bootstrap runs. Non-positive values of "B"
###             correspond to no bootstrapping.
### "boot.ci":  Probability value for bootstrap confidence intervals of
###             local FDR and prior pi0.
### "clus":     Use your cluster to compute bootstraps in parallel.
### "verbose":  TRUE or FALSE.
###
### OUTPUT
###
### Object of class "twilight" containing a data.frame with
### "pvalue":     Sorted input vector. 
### "qvalue":     q-values computed as described in Remark B of:
###               Storey JD and Tibshirani R (2003): Statistical significance
###               for genomewide studies, PNAS 100(16), pp. 9440-9445.
### "fdr":        Local false discovery rate averaged over 10 runs of SEP.
### "mean.fdr":   Bootstrap estimate of local false discovery rate.
### "lower.fdr":  Lower "boot.ci"-bootstrap confidence bound.
### "upper.fdr":  Upper "boot.ci"-bootstrap confidence bound.
###
### Additional output:
### "lambda":     Regularization parameter.
### "pi0":        Estimated prior probability.
### "boot.pi0":   Bootstrap estimate and "boot.ci"-bootstrap confidence
###               bounds.
### "boot.ci":    Passes "boot.ci".
### "effect":     Histogram of effect size distributions averaged over 10 runs of SEP.
###
### If "xin" is of class "twilight", the remaining slots are filled
### with corresponding input values. If "xin" is not of class 
### "twilight", these slots remain empty.

  ### Preliminary checks.
  if (class(xin)=="twilight"){
    pval  <- xin$result$pvalue
    score <- NULL
    check <- unlist(strsplit(xin$call," "))
    if (check[2]=="fc."){
      score <- xin$result$observed
    }
  }
  if (class(xin)!="twilight"){
    pval  <- xin
    rows  <- rownames(xin)
    score <- NULL
    index <- 1:length(pval)
    if (is.null(rownames(xin))){
      rows <- 1:length(pval)
    }
    if (is.unsorted(pval)){
      ix   <- order(pval)
      pval <- pval[ix]
      rows <- rows[ix]
      index <- index[ix]
    }
  }

  if (is.vector(pval)==FALSE){
    stop("Input must be vector of p-values or of class twilight.")
  }

  if ((max(pval)>1)|(min(pval)<0)){
    stop("Input vector must contain p-values in [0,1].")
  }

  
  ### Find suitable regularization parameter.
  if (is.null(lambda)){
    if (verbose){
      cat("Find suitable regularization parameter. ")
    }
    lambda <- twilight.getlambda(pval,verbose)
  }

  ### Compute the final estimate for pi0.
  funk.wrap1 <- function(a,b,c,d){

    ### Calling SEP. Returns binary vector (1=included,0=excluded).
    funk.sep <- function(ax,bx){
      x   <- .C("sep",
                as.double(ax),
                as.integer(length(ax)),
                as.double(bx),
                e = integer(length(ax)),
                f = double(1),PACKAGE="twilight")$e
      return(x)
    }

    bin.vec <- funk.sep(a,b)
    sep.pi0 <- sum(bin.vec)/length(bin.vec)    
    res     <- list(sep.pi0=sep.pi0)
    
    if (is.null(d)==FALSE){
      br         <- hist(d,plot=FALSE,br=100)$breaks
      sep.effect <- hist(d[as.logical(1-bin.vec)],plot=FALSE,br=br)   
      res        <- list(sep.pi0=sep.pi0,sep.effect=sep.effect)
    }

    if (verbose){cat(".")}    
    return(res)
  }
  
  ### 10 runs of SEP on the full input vector.
  if (verbose){cat("Run SEP. ")}

  orig.pval <- matrix(NA,length(pval),10)
  for (i in 1:10){
    orig.pval[,i] <- pval
  }

  if (is.null(clus)==TRUE){      
    if (verbose){cat("Wait for 10 dots. \n")}

    sep.H0 <- apply(orig.pval,2,funk.wrap1,lambda,pval,score)

    if (verbose){cat("\n")}
  }
  
  if (is.null(clus)==FALSE){
    if (verbose){cat("\n")}

    ### library(snow)
    cl <- makeCluster(clus)
    clusterEvalQ(cl,library(twilight))

    .twilight.lambda.xxx <<- lambda
    .twilight.pval.xxx   <<- pval
    .twilight.score.xxx  <<- score
    
    clusterExport(cl,c(".twilight.lambda.xxx",".twilight.pval.xxx",".twilight.score.xxx"))
    
    sep.H0 <- parCapply(cl,orig.pval,funk.wrap1,.twilight.lambda.xxx,.twilight.pval.xxx,.twilight.score.xxx)
    
    rm(.twilight.score.xxx,pos=1)
  }
  
  sep.pi0    <- numeric(10)
  sep.effect <- NaN
  for (i in 1:10){
    sep.pi0[i] <- sep.H0[[i]]$sep.pi0

    if (is.null(score)==FALSE){
      if (i==1){sep.effect <- sep.H0[[i]]$sep.effect}
      if (i!=1){sep.effect$counts <- sep.effect$counts + sep.H0[[i]]$sep.effect$counts}
    }

  }

  br.br <- c(0.01,0.02,0.04,0.05,0.1)    
  for (i in 1:length(br.br)){

    br <- quantile(pval,seq(0,1,by=br.br[i]))
      
    histmix <- hist(pval,plot=FALSE,br=br)
      
    x <- histmix$mids
    y <- 1/histmix$density

    if (sum(y==0)==0 & sum(y==Inf)==0 & sum(is.nan(y))==0){break}
  }
      
  smooth <- try(smooth.spline(x,y,df=7,w=1/x),silent=TRUE)
  
  if (class(smooth)=="try-error"){
    stop("Twilight cannot run properly.\n The number of features (genes, transcripts etc.) might be too small.\n Also, problems occur if the number of unique p-values is too small (e.g. in case of small sample sizes). Consider computing theoretical p-values using t.test or similar functions.")
  }

  sep.pi0 <- mean(sep.pi0)
  sep.H0  <- sep.pi0*predict(smooth,pval)$y
  
  sep.H0[which(sep.H0<0)] <- 0
  sep.H0[which(sep.H0>1)] <- 1

  if (is.null(score)==FALSE){
    ### mean histogram counts
    sep.effect$counts <- sep.effect$counts/10

    ### remove unchanged elements
    sep.effect$intensities <- NULL
    sep.effect$density     <- NULL
    sep.effect$xname       <- NULL
  }
  
  ### Bootstrap estimates.
  if (B>0){
    if (verbose){cat("Run SEP on bootstrap samples. ")}
    
    funk.wrap2 <- function(a,b,c){
      
      ### Calling SEP. Returns binary vector (1=included,0=excluded).
      funk.sep <- function(ax,bx){
        x   <- .C("sep",
                  as.double(ax),
                  as.integer(length(ax)),
                  as.double(bx),
                  e = integer(length(ax)),
                  f = double(1),PACKAGE="twilight")$e
        return(x)
      }
      
      bin.vec <- funk.sep(a,b)
      
      br.br <- c(0.01,0.02,0.04,0.05,0.1)
      
      for (i in 1:length(br.br)){
        
        br <- quantile(a,seq(0,1,by=br.br[i]))
        
        histmix <- hist(a,plot=FALSE,br=br)
        
        x <- histmix$mids
        y <- 1/histmix$density
        
        if (sum(y==0)==0 & sum(y==Inf)==0 & sum(is.nan(y))==0){break}
      }

      smooth <- try(smooth.spline(x,y,df=7,w=1/x),silent=TRUE)

      if (class(smooth)=="try-error"){
        stop("Twilight cannot run properly.\n The number of features (genes, transcripts etc.) might be too small.\n Also, problems occur if the number of unique p-values is too small (e.g. in case of small sample sizes). Consider computing theoretical p-values using t.test or similar functions.")
      }
      
      sep.pi0 <- sum(bin.vec)/length(bin.vec)
      sep.H0  <- sep.pi0*predict(smooth,c)$y
      
      sep.H0[which(sep.H0<0)] <- 0
      sep.H0[which(sep.H0>1)] <- 1

      if (verbose){cat(".")}

      res <- list(sep.pi0=sep.pi0,sep.H0=sep.H0)
      return(res)
    }

    
    boot.pval <- matrix(NA,length(pval),B)
    for (i in 1:B){
      boot.pval[,i] <- sort(sample(pval,replace=TRUE))
    }
    
    if (is.null(clus)==TRUE){      
      if (verbose){cat("Wait for",B,"dots. \n")}
      b.H0 <- apply(boot.pval,2,funk.wrap2,lambda,pval)
      if (verbose){cat("\n")}
    }
    
    if (is.null(clus)==FALSE){
      if (verbose){cat("\n")}
      b.H0 <- parCapply(cl,boot.pval,funk.wrap2,.twilight.lambda.xxx,.twilight.pval.xxx)
    }

    b.pi0 <- numeric(B)
    for (i in 1:B){
      b.pi0[i] <- b.H0[[i]]$sep.pi0
      b.H0[[i]]$sep.pi0 <- NULL
    }

    b.H0 <- as.data.frame(b.H0)
    
    mean.pi0 <- mean(b.pi0)
    ci.pi0   <- quantile(b.pi0,c((1-boot.ci)/2,boot.ci+(1-boot.ci)/2))

    mean.H0  <- apply(b.H0,1,mean)
    ci.H0    <- apply(b.H0,1,quantile,c((1-boot.ci)/2,boot.ci+(1-boot.ci)/2))

    lower.H0 <- ci.H0[1,]
    upper.H0 <- ci.H0[2,]
  }
  
  if (B<=0){
    m <- length(pval)

    mean.H0  <- rep(NaN,m)
    lower.H0 <- rep(NaN,m)
    upper.H0 <- rep(NaN,m)
    mean.pi0 <- NaN
    ci.pi0   <- rep(NaN,2)
  }

  if (is.null(clus)==FALSE){
    rm(.twilight.pval.xxx,pos=1)
    rm(.twilight.lambda.xxx,pos=1)    
    stopCluster(cl)
  }
  
  ### calculate q-values as described in Remark B of:
  ###
  ### Storey JD and Tibshirani R (2003): Statistical significance for
  ### genomewide studies, PNAS 100(16), pp. 9440-9445.
  ###
  ### BUT: set pi0 to SEP estimate.
  ###
  if (verbose){cat("Compute q-values. \n")}
  m       <- length(pval)
  qval    <- numeric(m)
  rp      <- rank(pval)
  qval[m] <- min(1,sep.pi0*pval[m]*m/rp[m])
  for (i in (m-1):1){
    qval[i] <- min(sep.pi0*pval[i]*m/rp[i],qval[i+1])
  }

  ### Prepare output.
  if (class(xin)=="twilight"){
    res <- xin

    res$result$qvalue     <- qval
    res$result$fdr        <- sep.H0
    res$result$mean.fdr   <- mean.H0
    res$result$lower.fdr  <- lower.H0
    res$result$upper.fdr  <- upper.H0
    res$lambda            <- lambda
    res$pi0               <- sep.pi0
    res$boot.pi0          <- data.frame(pi0=mean.pi0,lower.pi0=ci.pi0[1],upper.pi0=ci.pi0[2],row.names="")
    res$boot.ci           <- boot.ci
    res$effect            <- sep.effect
  }
  
  if (class(xin)!="twilight"){
    res <- list(result=data.frame(
                  observed=rep(NaN,m),
                  expected=rep(NaN,m),
                  candidate=rep(NaN,m),
                  pvalue=pval,
                  qvalue=qval,
                  fdr=sep.H0,
                  mean.fdr=mean.H0,
                  lower.fdr=lower.H0,
                  upper.fdr=upper.H0,
                  index=index,
                  row.names=rows),
                ci.line=NaN,
                quant.ci=NaN,
                lambda=lambda,
                pi0=sep.pi0,
                boot.pi0=data.frame(pi0=mean.pi0,lower.pi0=ci.pi0[1],upper.pi0=ci.pi0[2],row.names=""),
                boot.ci=boot.ci,
                effect=sep.effect,
                call=NaN)
    class(res) <- "twilight"
  }
  
  return(res)
}

twilight.pval <- function(xin,yin,method="fc",paired=FALSE,B=1000,yperm=NULL,balance=FALSE,quant.ci=0.95,s0=NULL,verbose=TRUE,filtering=FALSE){ 
### Function computes test statistics for paired or unpaired twosided
### t-test, Z-test or Fold change test.
###
### INPUT
###
### "xin":      Data matrix.
### "yin":      Vector of real valued group labels.
###
### Higher valued group labels are used as case samples and lower
### valued group label as control samples to test Case vs. Control.
###
### "method":   "t" for t statistic, "z" for Z statistic and "fc" for
###             Fold change equivalent (that is log ratio).
###             "pearson" for Pearson correlation.
###             "spearman" for Spearman rank correlation.
### "paired":   TRUE or FALSE. Depends on test setting.
### "B":        Number of permutations to estimate the null distribution
###             and the expected test statistics.
### "yperm":    Optional matrix of permuted class labels 0 and 1. Each row must
###             contain one permutation. No other permutations will be done.
### "balance":  TRUE or FALSE. Gives balanced or unbalanced permutations.
### "quant.ci": Probability value for confidence lines. Lines are symmetric
###             and denote the "quant.ci"-quantile of maximal absolute
###             differences between each permutation and the expected scores.
### "s0":       Fudge factor for Z test. If s0=NULL, s0 is set to median of
###             root pooled variances in test statistic.
### "verbose":  TRUE or FALSE.
### "filtering":TRUE or FALSE. Invokes filtering for permutations producing a complete null.
###
### OUTPUT
###
### Object of class "twilight" containing a data.frame with
### "observed":  Observed test statistics.
### "expected":  Mean of order statistics of the permutation statistics,
###              computed as described in:
###              Tusher VG, Tibshirani R and Chu G (2001): Significance
###              analysis of mircroarrays applied to the ionizing response,
###              PNAS 98(9), pp. 5116-5121.
### "candidate": Binary vector. "1" for genes exceeding the confidence lines.
### "pvalue":    Twosided test permutation p-values.
### "qvalue":    q-values computed as described in Remark B of:
###              Storey JD and Tibshirani R (2003): Statistical significance
###              for genomewide studies, PNAS 100(16), pp. 9440-9445.
###
### Additional output:
### "ci.line":   Quantile corresponding to "quant.ci".
### "pi0":       Estimated prior probability.
### "call":      String of function arguments.
### "quant.ci":  Passes "quant.ci".
###
### The remaining slots are left empty for function "twilight".
  
  ### extract data matrix if class(xin) is an expression set
  xin <- twilight.getmatrix(xin)

  ### check dimensions
  if (!is.matrix(xin)){
    stop("First input must be a matrix. \n")
  }

  if (!is.vector(yin)){
    stop("Second input must be a vector. \n")
  }

  if (length(yin)!=dim(xin)[2]){
    if (length(yin)!=dim(xin)[1]){
      stop("Dimensions of input matrix and length of index vector do not match. \n")
    }    
    xin <- t(xin)
  }

  if (length(yin)!=dim(xin)[2]){
    if (length(yin)!=dim(xin)[1]){
      stop("Dimensions of input matrix and length of index vector do not match. \n")
    }    
  }

  if ((method!="pearson")&(method!="spearman")){
    if (!is.null(yperm)){
      if (length(yin)!=dim(yperm)[2]){
        stop("Dimensions of permutation matrix and length of index vector do not match. \n")
      }
      
      y <- unique(yperm[1,])  
      if ((length(y)!=2)|(min(y)!=0)|(max(y)!=1)){
        stop("Labels in permutation matrix must be 0 and 1. \n")
      }
    }
  }

  if ((method!="pearson")&(method!="spearman")){
  ### translate index vector yin into binary vector with 1 as case and 0 as control samples.
    y <- sort(unique(yin),na.last=TRUE)
    
    if (length(y)!=2){
      stop("Samples must belong to TWO classes. \n")
    }
    
    y1 <- which(yin==y[1])
    y2 <- which(yin==y[2])
    yin[y1] <- 0
    yin[y2] <- 1
    
    if (paired){
      if (sum(yin)!=sum(1-yin)){
        stop("This is a PAIRED twosample test. The sizes of the two classes must be equal. \n")
      }
    }
  }

  ### transform to ranks for Spearman coefficient.
  if (method=="spearman"){
    yin <- rank(yin)
    xin <- t(apply(xin,1,rank))
  }  

  
  ### Z test with s0=0 is a t test.
  if (!is.null(s0)){
    if((s0==0)&(method=="z")){method <- "t"}
  }
  
  if (is.null(s0)){
    s0 <- 0
    if (method=="z"){
      s0 <- twilight.teststat(xin,yin,method="z",paired=paired)$s0
    }
  }

  
  ### prepare matrix of permuted index labels without filtering.
  if ((!filtering)&is.null(yperm)){
    if ((method!="pearson")&(method!="spearman")){
      yperm <- twilight.combi(yin,pin=paired,bin=balance)

      if (!is.null(yperm)){
        if (nrow(yperm)>B){yperm <- NULL} ### turns off compulsive complete enumeration if a small B was chosen.
      }
      
      if ((!is.null(yperm))&(verbose)){cat("Complete enumeration possible. \n")}
      if (( is.null(yperm))&(verbose)){cat("No complete enumeration. Prepare permutation matrix. \n")}
      
      if ((is.null(yperm))&(!paired)){
        yperm <- twilight.permute.unpair(yin,B,balance)
      }
      if ((is.null(yperm))&(paired)){
        yperm <- twilight.permute.pair(yin,B,balance)
      }
    }
    if ((method=="pearson")|(method=="spearman")){
      yperm <- twilight.permute.unpair(yin,B,bal=FALSE)
    }
  }

  
  ### prepare matrix of permuted index labels with filtering.
  if ((filtering)&is.null(yperm)){
    if (balance){cat("Note that the filtering is done on UNbalanced permutations although you have chosen 'balance=TRUE'. \n")}
    balance <- FALSE
    
    num.perm <- B
    num.take <- min(50,ceiling(num.perm/20))
    
    yperm <- switch(method,
                    t = twilight.filtering(xin,yin,method="t",paired,s0,verbose,num.perm,num.take),
                    z = twilight.filtering(xin,yin,method="z",paired,s0,verbose,num.perm,num.take),
                    fc = twilight.filtering(xin,yin,method="fc",paired,s0,verbose,num.perm,num.take),
                    pearson = twilight.filtering(xin,yin,method="pearson",paired,s0,verbose,num.perm,num.take),
                    spearman = twilight.filtering(xin,yin,method="spearman",paired,s0,verbose,num.perm,num.take),
                    gcFirst=TRUE)
  }
  
  B <- dim(yperm)[1]

  ### compute observed test statistics.
  funk1 <- function(a, b, c, d, s) {
    .C(ifelse(paired,"paired","unpaired"), 
       as.integer(a),
       as.integer(sum(a)),
       as.integer(sum(1-a)),       
       as.double(t(b)),
       as.integer(nrow(b)),
       as.integer(ncol(b)),
       as.integer(c), 
       as.integer(which(d==1)-1),
       as.integer(which(d==0)-1),
       as.double(s),
       e = double(nrow(b)),
       fudge = double(1), PACKAGE = "twilight")$e
  }
  
  if (verbose){cat("Compute vector of observed statistics. \n")}


  if ((method!="pearson")&(method!="spearman")){
    stime <- system.time(stat.obs <- switch(method,
                                            t = funk1(yin,xin,1,yin,s0),
                                            z = funk1(yin,xin,2,yin,s0),
                                            fc = funk1(yin,xin,3,yin,s0)),gcFirst=TRUE)
  }
  
  if ((method=="pearson")|(method=="spearman")){
    funk2 <- function(a,b){
      .C("corsingle",
         as.double(a),
         as.double(t(b)),
         as.integer(nrow(b)),
         as.integer(ncol(b)),
         e=double(nrow(b)),PACKAGE="twilight")$e
    }
    
    stime <- system.time(stat.obs <- funk2(yin,xin),gcFirst=TRUE)
  }

  

  ### compute twosided test p-values from permutations.  
  ### sort permutation scores and calculate expected scores as described in:
  ### 
  ### Tusher VG, Tibshirani R and Chu G (2001): Significance
  ### analysis of mircroarrays applied to the ionizing response,
  ### PNAS 98(9), pp. 5116-5121.
  ###
  funk3 <- function(a,b,c,orig,s){
    x <- .C(ifelse(paired,"pairedperm","unpairedperm"),
            as.integer(t(a)),
            as.integer(nrow(a)),
            as.integer(sum(a[1,])),
            as.integer(sum(1-a[1,])),
            as.double(t(b)),
            as.integer(nrow(b)),
            as.integer(ncol(b)),
            as.integer(c),
            as.integer(which(orig==1)-1),
            as.integer(which(orig==0)-1),
            as.double(s),
            e=double(nrow(b)),
            f=double(nrow(b)),PACKAGE="twilight"
            )
    res <- list(exp=x$e,pval=x$f)
    return(res)
  }
  
  if (verbose){cat(paste("Compute expected scores and p-values. This will take approx.",round(max(stime[1:3])*nrow(yperm)),"seconds. \n"))}

  if ((method!="pearson")&(method!="spearman")){
    stat.exp <- switch(method,
                       t = funk3(yperm,xin,1,yin,s0),
                       z = funk3(yperm,xin,2,yin,s0),
                       fc = funk3(yperm,xin,3,yin,s0))
  }
  if ((method=="pearson")|(method=="spearman")){
    funk4 <- function(a,b){
      x <- .C("corperm",
              as.double(t(a)),
              as.integer(nrow(a)),
              as.double(t(b)),
              as.integer(nrow(b)),
              as.integer(ncol(b)),
              e=double(nrow(b)),
              f=double(nrow(b)),PACKAGE="twilight"
              )
      res <- list(exp=x$e,pval=x$f)
      return(res)
    }

    stat.exp <- funk4(yperm,xin)    
  }

  pval     <- stat.exp$pval
  stat.exp <- stat.exp$exp
  stat.exp <- stat.exp[rank(stat.obs)]
  
  ### sort all values according to test scores.
  ix <- order(abs(stat.obs),decreasing=TRUE)
  stat.obs <- stat.obs[ix]
  stat.exp <- stat.exp[ix]
  pval     <- pval[ix]
  rows     <- rownames(xin)[ix]
  index    <- 1:length(stat.obs)
  index    <- index[ix]
  
  if (is.null(rownames(xin))){
    rows <- ix
  }
  
  ### calculate q-values as described in Remark B of:
  ###
  ### Storey JD and Tibshirani R (2003): Statistical significance for
  ### genomewide studies, PNAS 100(16), pp. 9440-9445.
  ###
  if (verbose){cat("Compute q-values. \n")}
  l <- seq(0,0.95,by=0.01)
  m <- length(pval)
  p <- numeric()
  for (i in 1:length(l)){
    p <- c(p,sum(pval>l[i])/(m*(1-l[i])))
  }  

  pi.model <- lm(p ~ ns(l,df=3))
  pi0 <- predict(pi.model,data.frame(l=c(l,1)))
  pi0 <- min(pi0[length(pi0)],1)

  qval    <- numeric(m)
  rp      <- rank(pval)
  qval[m] <- min(1,pi0*pval[m]*m/rp[m])
  for (i in (m-1):1){
    qval[i] <- min(pi0*pval[i]*m/rp[i],qval[i+1])
  }

  ### compute permutation based confidence lines for plot1.
  if (verbose){cat("Compute values for confidence lines. \n")}
  funk5 <- function(a,b,c,d,orig,s){
    x <- .C(ifelse(paired,"pairedci","unpairedci"),
            as.integer(t(a)),
            as.integer(nrow(a)),
            as.integer(sum(a[1,])),
            as.integer(sum(1-a[1,])),
            as.double(t(b)),
            as.integer(nrow(b)),
            as.integer(ncol(b)),
            as.integer(c),
            as.double(d),
            as.integer(which(orig==1)-1),
            as.integer(which(orig==0)-1),
            as.double(s),
            e=double(nrow(a)),PACKAGE="twilight"
            )$e
  }

  ### compute confidence bounds
  ci.sel  <- sample(1:B,min(1000,B))
  if ((method!="pearson")&(method!="spearman")){
    ci.line <- switch(method,
                      t = funk5(yperm[ci.sel,],xin,1,stat.exp,yin,s0),
                      z = funk5(yperm[ci.sel,],xin,2,stat.exp,yin,s0),
                      fc = funk5(yperm[ci.sel,],xin,3,stat.exp,yin,s0))
  }
  if ((method=="pearson")|(method=="spearman")){
    funk6 <- function(a,b,c){
      .C("corci",
         as.double(t(a)),
         as.integer(nrow(a)),
         as.double(t(b)),
         as.integer(nrow(b)),
         as.integer(ncol(b)),
         as.double(c),
         e=double(nrow(a)),PACKAGE="twilight"
         )$e
    }
    
    ci.line <- funk6(yperm[ci.sel,],xin,stat.exp)
  }
  ci.line <- quantile(ci.line,quant.ci)

  ### mark genes with differences exceeding the confidence lines.
  cand <- as.numeric( abs(stat.obs-stat.exp)>ci.line )

  if ((method!="pearson")&(method!="spearman")){
    call <- paste("Test: ",method,". Paired: ",paired,". Number of permutations: ",B,". Balanced: ",balance,".",sep="")
  }
  if ((method=="pearson")|(method=="spearman")){
    call <- paste("Test: ",method,". Number of permutations: ",B,".",sep="")
  }
  if (filtering){
    call <- paste(call,"Permutation filtering was performed.")
  }
  
  res <- list(result=data.frame(
                observed=stat.obs,
                expected=stat.exp,
                candidate=cand,
                pvalue=pval,
                qvalue=qval,
                fdr=rep(NaN,m),
                mean.fdr=rep(NaN,m),
                lower.fdr=rep(NaN,m),
                upper.fdr=rep(NaN,m),
                index=index,
                row.names=rows),
              s0=s0,
              ci.line=ci.line,
              quant.ci=quant.ci,
              lambda=NaN,
              pi0=pi0,
              boot.pi0=NaN,
              boot.ci=NaN,
              effect=NaN,
              call=call)
  class(res) <- "twilight"
  
  return(res)
}

twilight.permute.unpair <- function(v,m,bal=TRUE){
### do "m" permutations of the vector "v" containing unpaired group labels.

  x <- sort(unique(v))
  
  if (bal==FALSE){
    M <- matrix(NA,m,length(v))
    M[1,] <- v
    for (i in 2:m){
      M[i,] <- sample(v)
    }
  }

  if (bal==TRUE){
    M  <- matrix(NA,m,length(v))

    for (i in 1:(m%/%2)){
      v1 <- sample(which(v==x[1]))
      v2 <- sample(which(v==x[2]))

      n1 <- length(v1)/2
      y1 <- c( rep(x[1],floor(n1))  , rep(x[2],ceiling(n1)) )
      y2 <- c( rep(x[1],ceiling(n1)), rep(x[2],floor(length(v)-n1-ceiling(n1))) )
      y  <- c(y1,y2)
      z  <- c(v1,v2)
      z  <- sort(z,index.return=TRUE)

      M[i,] <- y[z$ix]
    }

    for (i in (m%/%2+1):m){
      v1 <- sample(which(v==x[1]))
      v2 <- sample(which(v==x[2]))

      n1 <- length(v2)/2
      y1 <- c( rep(x[2],floor(n1))  , rep(x[1],ceiling(n1)) )
      y2 <- c( rep(x[2],ceiling(n1)), rep(x[1],floor(length(v)-n1-ceiling(n1))) )
      y  <- c(y1,y2)
      z  <- c(v1,v2)
      z  <- sort(z,index.return=TRUE)

      M[i,] <- y[z$ix]
    }
    
    M[1,] <- v
    rownames(M) <- NULL
  }

  return(M)
}

\name{twilight.permute.unpair}
\alias{twilight.permute.unpair}
\title{ Permutation matrix of unpaired class labels }
\description{The function returns a matrix where each row is a (un)balanced permutation of the input twosample class labels.
}
\usage{
twilight.permute.unpair(v, m, bal = TRUE)
}
\arguments{
  \item{v}{ A binary vector representing class labels in original order. }
  \item{m}{ A numerical value giving the number of permutations. }
  \item{bal}{ Logical value. Results in balanced or unbalanced permutations. }
}
\value{Returns a matrix where each row contains one permuted vector of class labels. Note that even for balanced permutations, the first row always contains the original vector.}
\references{
Scheid S and Spang R (2004): A stochastic downhill search algorithm for estimating the local false discovery rate, \emph{IEEE TCBB} \bold{1(3)}, 98--108.

Scheid S and Spang R (2005): twilight; a Bioconductor package for estimating the local false discovery rate, \emph{Bioinformatics} \bold{21(12)}, 2921--2922. 

Scheid S and Spang R (2006): Permutation filtering: A novel concept for significance analysis of large-scale genomic data, in: Apostolico A, Guerra C, Istrail S, Pevzner P, and Waterman M (Eds.): \emph{Research in Computational Molecular Biology: 10th Annual International Conference, Proceedings of RECOMB 2006, Venice, Italy, April 2-5, 2006}. Lecture Notes in Computer Science vol. 3909, Springer, Heidelberg, pp. 338-347.
}
\author{ Stefanie Scheid }
\seealso{ \code{\link{twilight.permute.pair}}, \code{\link{twilight.combi}} }
\keyword{ datagen }

\name{twilight.combi}
\alias{twilight.combi}
\title{ All permutations of a binary vector }
\description{
For a given binary input vector, the function completely enumerates all possible permutations.
}
\usage{
twilight.combi(xin, pin, bin)
}
\arguments{
  \item{xin}{ Binary input vector, e.g. class labels. }
  \item{pin}{ Logical value. \code{TRUE} if samples are paired, \code{FALSE} if not. }
  \item{bin}{ Logical value. \code{TRUE} if permutations should be balanced, \code{FALSE} if not. }
}
\details{
Please note, that the resulting permutations are always as "balanced" as possible. The balancing is done for the smaller subsample. If its sample size is odd, say 5, \code{twilight.combi} computes all permutations with 2 or 3 samples unchanged. In the paired case, the output matrix contains only one half of all permutations. The second half is simply 1-\code{output} which leads to the same absolute test statistics in a paired test.
}
\value{
Returns a matrix where each row contains one permuted vector. Note that even for balanced permutations, the first row always contains the original vector. If the number of rows exceeds 10000, \code{NULL} is returned.
}
\references{
Scheid S and Spang R (2004): A stochastic downhill search algorithm for estimating the local false discovery rate, \emph{IEEE TCBB} \bold{1(3)}, 98--108.

Scheid S and Spang R (2005): twilight; a Bioconductor package for estimating the local false discovery rate, \emph{Bioinformatics} \bold{21(12)}, 2921--2922. 

Scheid S and Spang R (2006): Permutation filtering: A novel concept for significance analysis of large-scale genomic data, in: Apostolico A, Guerra C, Istrail S, Pevzner P, and Waterman M (Eds.): \emph{Research in Computational Molecular Biology: 10th Annual International Conference, Proceedings of RECOMB 2006, Venice, Italy, April 2-5, 2006}. Lecture Notes in Computer Science vol. 3909, Springer, Heidelberg, pp. 338-347.
}
\author{ Stefanie Scheid }
\seealso{ \code{\link{twilight.permute.pair}}, \code{\link{twilight.permute.unpair}} }

\examples{
x <- c(rep(0,4),rep(1,3))
y <- twilight.combi(x,pin=FALSE,bin=FALSE)
}
\keyword{ datagen }

\name{twilight.getlambda}
\alias{twilight.getlambda}
\title{ Internal function to compute regularization parameter lambda }
\description{The SEP method optionally includes a penalty term in order to estimate the percentage of non-significant differences/genes.}
\usage{twilight.getlambda(xin, verbose = TRUE)}
\arguments{
  \item{xin}{A numerical vector containing \eqn{p}-values.}
  \item{verbose}{Logical value for message printing.}
}
\details{The function finds a suitable regularization parameter \eqn{\lambda}. For a sequence of lambdas, the objective function of SEP is computed for subsamples of the \eqn{p-value} vector \code{xin}. The final estimate is chosen based upon a Wilcoxon test comparison between objective function values of \eqn{\lambda=0} and each \eqn{\lambda>0}. The penalized objective function should not differ a lot from the unpenalized one. Therefore, the highest lambda that leads to a non-significant difference in means is chosen.}
\value{Returns numerical value.}
\references{
Scheid S and Spang R (2004): A stochastic downhill search algorithm for estimating the local false discovery rate, \emph{IEEE TCBB} \bold{1(3)}, 98--108.

Scheid S and Spang R (2005): twilight; a Bioconductor package for estimating the local false discovery rate, \emph{Bioinformatics} \bold{21(12)}, 2921--2922. 

Scheid S and Spang R (2006): Permutation filtering: A novel concept for significance analysis of large-scale genomic data, in: Apostolico A, Guerra C, Istrail S, Pevzner P, and Waterman M (Eds.): \emph{Research in Computational Molecular Biology: 10th Annual International Conference, Proceedings of RECOMB 2006, Venice, Italy, April 2-5, 2006}. Lecture Notes in Computer Science vol. 3909, Springer, Heidelberg, pp. 338-347.
}
\author{ Stefanie Scheid }
\seealso{ \code{\link{twilight}} }
\keyword{ internal }

\name{twilight.teststat}
\alias{twilight.teststat}
\title{ Interface to the test statistics provided within 'twilight' }
\description{
A function to compute two-sample t, Z and fold change equivalent test statistics (paired or unpaired) and correlation coefficients.
}
\usage{
twilight.teststat(xin, yin, method = "fc", paired = FALSE, s0 = NULL)
}
\arguments{
  \item{xin}{ Either an expression set (\code{ExpressionSet}) or a data matrix with rows corresponding to features and columns corresponding to samples. }
  \item{yin}{ A numerical vector containing class labels. The higher label denotes the case, the lower label the control samples to test case vs. control. For correlation scores, \code{yin} can be any numerical vector of length equal to the number of samples. }
  \item{method}{ Character string: \code{"fc"} for fold change equivalent test (that is log ratio test), \code{"t"} for t-test, and \code{"z"} for Z-test of Tusher et al. (2001). With \code{"pearson"} or \code{"spearman"}, the test statistic is either Pearson's correlation coefficient or Spearman's rank correlation coefficient.}
  \item{paired}{ Logical value. Depends on whether the samples are paired. Ignored if \code{method="pearson"} or \code{method="spearman"}.}
  \item{s0}{ Fudge factor for variance correction in the Z-test. Takes effect only if \code{method="z"}. If \code{s0=NULL}: The fudge factor is set to the median of the pooled standard deviations.}
}
\details{
Please see vignette for detailed information.
}
\value{
Returns a list with two components: a numerical vector of observed test statistics \code{observed}. Each entry corresponds to one row of the input data matrix. Also, the estimated fudge factor \code{s0} is returned. In any other case except \code{method="z"}, \code{s0} is zero.
}
\references{
Scheid S and Spang R (2004): A stochastic downhill search algorithm for estimating the local false discovery rate, \emph{IEEE TCBB} \bold{1(3)}, 98--108.

Scheid S and Spang R (2005): twilight; a Bioconductor package for estimating the local false discovery rate, \emph{Bioinformatics} \bold{21(12)}, 2921--2922. 

Scheid S and Spang R (2006): Permutation filtering: A novel concept for significance analysis of large-scale genomic data, in: Apostolico A, Guerra C, Istrail S, Pevzner P, and Waterman M (Eds.): \emph{Research in Computational Molecular Biology: 10th Annual International Conference, Proceedings of RECOMB 2006, Venice, Italy, April 2-5, 2006}. Lecture Notes in Computer Science vol. 3909, Springer, Heidelberg, pp. 338-347.

Tusher VG, Tibshirani R and Chu G (2001): Significance analysis of mircroarrays applied to the ionizing response, \emph{PNAS} \bold{98(9)}, 5116--5121.
}
\author{ Stefanie Scheid }
\seealso{ \code{\link{twilight.pval}} }

\examples{
### Z-test on random values
M <- matrix(rnorm(20000),nrow=1000)
id <- c(rep(1,10),rep(0,10))
stat <- twilight.teststat(M,id,method="z")

### Pearson correlation
id <- 1:20
stat <- twilight.teststat(M,id,method="pearson")
}
\keyword{ nonparametric }

\name{plot.twilight}
\alias{plot.twilight}
\title{ Plot function for twilight objects }
\description{Interface to plotting of \code{twilight} objects. Produces one of five possible plots.}
\usage{\method{plot}{twilight}(x, which = NULL, grayscale = FALSE, legend = TRUE, \dots)}
\arguments{
  \item{x}{ An object of class twilight. }
  \item{which}{ A character string specifying the plot to be made. }
  \item{grayscale}{ Logical value. Specifying whether plots should be colored or grayscaled. Only necessary for "scores" and "fdr". }
  \item{legend}{ Logical value. Produces a legend for "scores" and "effectsize". A legend for "fdr" is only available if bootstrap estimates exist. }
  \item{\dots}{ Additional graphical arguments. }
}
\details{
Option \code{which="scores"} plots the expected versus the observed test statistics and draws confidence lines calculated from permutations. This plot is similar to plots in Tusher et al. (2001).

Option \code{which="qvalues"} plots \eqn{q}-values versus the number of rejected hypotheses.

Option \code{which="fdr"} plots \eqn{p}-values versus 1 - local false discovery rate, that is the conditional probability of being significant given the corresponding \eqn{p}-value, plus bootstrap estimates if computed. Bottom ticks are 1\%-quantiles of \eqn{p}-values.

Option \code{which="volcano"} results in the volcano plot, that is observed score versus 1 - local false discovery rate. Bottom ticks are 1\%-quantiles of scores.

Option \code{which="effectsize"} plots the observed fold change equivalent score distribution overlaid by the estimated effect size distribution, that is distribution of scores under the alternative. This plot is only available if function \code{twilight.pval} was applied with \code{method="fc"} as fold change equivalent scores are computed from log ratios.

Option \code{which="table"} tabulates histogram \code{"effectsize"}.
}
\value{No value is returned except for "table".}
\references{
Scheid S and Spang R (2004): A stochastic downhill search algorithm for estimating the local false discovery rate, \emph{IEEE TCBB} \bold{1(3)}, 98--108.

Scheid S and Spang R (2005): twilight; a Bioconductor package for estimating the local false discovery rate, \emph{Bioinformatics} \bold{21(12)}, 2921--2922. 

Scheid S and Spang R (2006): Permutation filtering: A novel concept for significance analysis of large-scale genomic data, in: Apostolico A, Guerra C, Istrail S, Pevzner P, and Waterman M (Eds.): \emph{Research in Computational Molecular Biology: 10th Annual International Conference, Proceedings of RECOMB 2006, Venice, Italy, April 2-5, 2006}. Lecture Notes in Computer Science vol. 3909, Springer, Heidelberg, pp. 338-347.

Tusher VG, Tibshirani R and Chu G (2001): Significance analysis of mircroarrays applied to the ionizing response, \emph{PNAS} \bold{98(9)}, 5116--5121.
 }
\author{ Stefanie Scheid }
\seealso{ \code{\link{twilight.pval}}, \code{\link{twilight}} }
\examples{
### contains a twilight object created by function twilight
data(exfdr)
plot(exfdr)
}
\keyword{ hplot }

\name{print.twilight}
\alias{print.twilight}
\title{ Print function for twilight objects }
\description{
Extract and print information about a twilight object.
}
\usage{\method{print}{twilight}(x, \dots)}
\arguments{
  \item{x}{Input object of class \code{twilight}.}
  \item{\dots}{ Additional printing arguments. }
}
\value{
No value is returned.
}
\references{
Scheid S and Spang R (2004): A stochastic downhill search algorithm for estimating the local false discovery rate, \emph{IEEE TCBB} \bold{1(3)}, 98--108.

Scheid S and Spang R (2005): twilight; a Bioconductor package for estimating the local false discovery rate, \emph{Bioinformatics} \bold{21(12)}, 2921--2922. 

Scheid S and Spang R (2006): Permutation filtering: A novel concept for significance analysis of large-scale genomic data, in: Apostolico A, Guerra C, Istrail S, Pevzner P, and Waterman M (Eds.): \emph{Research in Computational Molecular Biology: 10th Annual International Conference, Proceedings of RECOMB 2006, Venice, Italy, April 2-5, 2006}. Lecture Notes in Computer Science vol. 3909, Springer, Heidelberg, pp. 338-347.
}
\author{ Stefanie Scheid }
\seealso{ \code{\link{plot.twilight}} }
\examples{
### contains a twilight object created by function twilight
data(exfdr)
print(exfdr)
}
\keyword{ print }

\name{expval}
\alias{expval}
\title{ Example of twilight.pval result }
\docType{data}
\description{
Application of function \code{twilight.pval} on leukemia data set of Golub et al. (1999), as given in \code{data(Golub_Merge)} in \code{library(golubEsets)}.

First step was the variance-stabilizing normalization of Huber et al. (2002) in \code{library(vsn)}: \code{golubNorm <- justvsn(Golub_Merge)}.

The function call was then \code{expval <- twilight.pval(golubNorm,id)} with \code{id <- as.numeric(Golub_Merge$ALL.AML)}.
}
\usage{data(expval)}
\format{A twilight object.}
\references{
Golub TR, Slonim DK, Tamayo P, Huard C, Gaasenbeek M, Mesirov JP, Coller H, Loh ML, Downing JR, Caligiuri MA, Bloomfield CD and Lander ES (1999): Molecular Classification of Cancer: Class Discovery and Class Prediction by Gene Expression Monitoring, \emph{Science} \bold{286}, 531--537.

Huber W, von Heydebreck A, Sultmann H, Poustka A and Vingron M (2002): Variance stabilization applied to microarray data calibration and to the quantification of differential expression, \emph{Bioinformatics} \bold{18}, suppl. 1, S96--S104.

Scheid S and Spang R (2004): A stochastic downhill search algorithm for estimating the local false discovery rate, \emph{IEEE TCBB} \bold{1(3)}, 98--108.

Scheid S and Spang R (2005): twilight; a Bioconductor package for estimating the local false discovery rate, \emph{Bioinformatics} \bold{21(12)}, 2921--2922. 

Scheid S and Spang R (2006): Permutation filtering: A novel concept for significance analysis of large-scale genomic data, in: Apostolico A, Guerra C, Istrail S, Pevzner P, and Waterman M (Eds.): \emph{Research in Computational Molecular Biology: 10th Annual International Conference, Proceedings of RECOMB 2006, Venice, Italy, April 2-5, 2006}. Lecture Notes in Computer Science vol. 3909, Springer, Heidelberg, pp. 338-347.

Tusher VG, Tibshirani R and Chu G (2001): Significance analysis of mircroarrays applied to the ionizing response, \emph{PNAS} \bold{98(9)}, 5116--5121.
}
\keyword{datasets}

\name{twilight}
\alias{twilight}
\title{ Estimation of the local false discovery rate }
\description{
The function performs the successive exclusion procedure (SEP) as described in Scheid and Spang (2004).
}
\usage{
twilight(xin, lambda = NULL, B = 0, boot.ci = 0.95, clus = NULL, verbose = TRUE)
}
\arguments{
  \item{xin}{ Numerical vector of \eqn{p}-values or a \code{twilight} object. }
  \item{lambda}{ Numerical value denoting the penalty factor. If not specified, the function searchs for an appropriate regularization parameter. }
  \item{B}{ Numerical value specifying the number of bootstrap samples. If not specified, no bootstrap estimates are calculated. }
  \item{boot.ci}{ Numerical value denoting the probability value for bootstrap confidence intervals of local false discovery rate and prior pi0. }
  \item{clus}{ A list or numerical value to be passed to \code{makeCluster(clus,...)} in \code{library(snow)}. If specified, bootstrapping is performed in parallel. No checks on \code{clus} are performed. Please make sure that \code{makeCluster(clus)} works properly in your environment. }
  \item{verbose}{ Logical value for message printing. }
}
\details{
In short, the successive exclusion procedure divides the set of p-values into two parts. The first part is chosen such that it resembles a uniform distribution while containing as many p-values as possible. This set of p-values represents the set of p-values derived from non-induced genes. The height of the uninform distribution is a natural estimate for the mixture parameter pi0. The p-value not contained in the uniform part serve as representatives of p-values derived from induced genes. Their distribution is the basis of the final estimate of the local false discovery rate.

NOTE: Library(snow) has to be loaded manually. It is not loaded as part of 'suggests' or 'depends' because it is only available under UNIX. If twilight does not work with the current version of snow, please send a report.
}
\value{
Returns a \code{twilight} object consisting of a \code{data.frame} named \code{result} with variables
  \item{pvalue}{Sorted input vector.}
  \item{qvalue}{\eqn{q}-values computed as described in Storey and Tibshirani (2003) with new estimate \code{pi0}.}
  \item{index}{Index of the original ordering.}
  \item{fdr}{Local false discovery rate averaged over 10 runs of SEP.}
  \item{mean.fdr}{Bootstrap estimate of local false discovery rate.}
  \item{lower.fdr}{Lower \code{boot.ci}-bootstrap confidence bound.}
  \item{upper.fdr}{ Upper \code{boot.ci}-bootstrap confidence bound.}
Values are sorted by \code{pvalue}.
}
\note{
Additional output consists of

\tabular{ll}{
  \code{lambda} \tab Regularization parameter. \cr
  \code{pi0} \tab SEP estimate of prior probability. \cr
  \code{boot.pi0} \tab Bootstrap estimate and \code{boot.ci}-bootstrap confidence bounds. \cr
  \code{boot.ci} \tab Passes \code{boot.ci} for plotting. \cr
  \code{effect} \tab Histogram of effect size distributions averaged over 10 runs of SEP. \cr
}

If \code{xin} is of class \code{twilight}, the remaining slots are filled with corresponding input values. If \code{xin} is not of class \code{twilight}, these slots remain empty.
}
\references{
Scheid S and Spang R (2004): A stochastic downhill search algorithm for estimating the local false discovery rate, \emph{IEEE TCBB} \bold{1(3)}, 98--108.

Scheid S and Spang R (2005): twilight; a Bioconductor package for estimating the local false discovery rate, \emph{Bioinformatics} \bold{21(12)}, 2921--2922. 

Scheid S and Spang R (2006): Permutation filtering: A novel concept for significance analysis of large-scale genomic data, in: Apostolico A, Guerra C, Istrail S, Pevzner P, and Waterman M (Eds.): \emph{Research in Computational Molecular Biology: 10th Annual International Conference, Proceedings of RECOMB 2006, Venice, Italy, April 2-5, 2006}. Lecture Notes in Computer Science vol. 3909, Springer, Heidelberg, pp. 338-347.

Storey JD and Tibshirani R (2003): Statistical significance for genomewide studies, \emph{PNAS} \bold{100(16)}, 9440--9445.
}
\author{ Stefanie Scheid }
\seealso{ \code{\link{twilight.pval}}, \code{\link{plot.twilight}}, \code{\link{exfdr}} }

\examples{
### twilight object created with B=1000 bootstrap samples
data(exfdr) 
print(exfdr)
plot(exfdr)
}
\keyword{ nonparametric }

\name{twilight.filtering}
\alias{twilight.filtering}
\title{ Permutation filtering }
\description{
The function call invokes the filtering for permutations of class labels that produce a set of complete null scores. Depending on the test setting, the algorithm iteratively generates valid permutations of the class labels and computes scores. These are transformed to pooled p-values and each set of permutation p-values is tested for uniformity. Permutations with acceptable uniform p-value distributions are kept. The search stops if either the number \code{num.perm} of wanted permutations is reached or if the number of possible unique(!) permutations is smaller than \code{num.perm}. The default values are similar to function \code{twilight.pval} but please note the details below.
}
\usage{
twilight.filtering(xin, yin, method = "fc", paired = FALSE, s0 = 0, verbose = TRUE, num.perm = 1000, num.take = 50)
}
\arguments{
  \item{xin}{ Either an expression set (\code{ExpressionSet}) or a data matrix with rows corresponding to features and columns corresponding to samples. }
  \item{yin}{ A numerical vector containing class labels. The higher label denotes the case, the lower label the control samples to test case vs. control. For correlation scores, \code{yin} can be any numerical vector of length equal to the number of samples. }
  \item{method}{ Character string: \code{"fc"} for fold change equivalent test (that is log ratio test), \code{"t"} for t-test, and \code{"z"} for Z-test. With \code{"pearson"} or \code{"spearman"}, the test statistic is either Pearson's correlation coefficient or Spearman's rank correlation coefficient.}
  \item{paired}{ Logical value. Depends on whether the samples are paired. Ignored if \code{method="pearson"} or \code{method="spearman"}.}
 \item{s0}{ Fudge factor for variance correction in the Z-test. Takes effect only if \code{method="z"}. If \code{s0=0}: The fudge factor is set to the median of the pooled standard deviations.}
  \item{verbose}{ Logical value for message printing. }
  \item{num.perm}{ Number of permutations. Within \code{twilight.pval}, \code{num.perm} is set to \code{B}. }
  \item{num.take}{ Number of permutations kept in each step of the iterative filtering. Within \code{twilight.pval}, \code{num.take} is set to the minimum of 50 and \code{ceiling(num.perm/20)}. }
}
\details{
See vignette.
}
\value{
 Returns a matrix with permuted input labels \code{yin} as rows. Please note that this matrix is already translated into binary labels for two-sample testing or to ranks if Spearman's correlation was chosen. The resulting permutation matrix can be directly passed into function \code{twilight.pval}. Please note that the first row always contains the original input \code{yin} to be consistent with the other permutation functions in package \code{twilight}.
}
\references{
Scheid S and Spang R (2004): A stochastic downhill search algorithm for estimating the local false discovery rate, \emph{IEEE TCBB} \bold{1(3)}, 98--108.

Scheid S and Spang R (2005): twilight; a Bioconductor package for estimating the local false discovery rate, \emph{Bioinformatics} \bold{21(12)}, 2921--2922. 

Scheid S and Spang R (2006): Permutation filtering: A novel concept for significance analysis of large-scale genomic data, in: Apostolico A, Guerra C, Istrail S, Pevzner P, and Waterman M (Eds.): \emph{Research in Computational Molecular Biology: 10th Annual International Conference, Proceedings of RECOMB 2006, Venice, Italy, April 2-5, 2006}. Lecture Notes in Computer Science vol. 3909, Springer, Heidelberg, pp. 338-347.
}
\author{ Stefanie Scheid }
\seealso{ \code{\link{twilight.pval}} }
\examples{
\dontrun{
### Leukemia data set of Golub et al. (1999).
library(golubEsets)
data(Golub_Train)

### Variance-stabilizing normalization of Huber et al. (2002).
library(vsn)
golubNorm <- justvsn(Golub_Train)

### A binary vector of class labels.
id <- as.numeric(Golub_Train$ALL.AML)

### Do an unpaired t-test.
### Let's have a quick example with 50 filtered permutations only.
### With num.take=10, we only need 5 iteration steps.
yperm <- twilight.filtering(golubNorm,id,method="t",num.perm=50,num.take=10)
dim(yperm)

### Let's check that the filtered permutations really produce uniform p-value distributions.
### The first row is the original labeling, so we try the second permutation.
yperm <- yperm[-1,]
b <- twilight.pval(golubNorm,yperm[1,],method="t",yperm=yperm)
hist(b$result$pvalue)
}
}
\keyword{ datagen }

\name{twilight.pval}
\alias{twilight.pval}
\title{ Compute p-values from expression sets }
\description{
A function to compute two-sample t, Z and fold change equivalent test statistics (paired or unpaired) and correlation coefficients. Based on permutations, expected test statistics as given in Tusher et al. (2001) and empirical \eqn{p}-values are computed. Additional output are \eqn{q}-values computed as given in Storey and Tibshirani (2003). The resulting object is of class \code{twilight} and can be passed to functions \code{twilight} or \code{plot.twilight}.
}
\usage{
twilight.pval(xin, yin, method = "fc", paired = FALSE, B = 1000, yperm = NULL, balance = FALSE, quant.ci = 0.95, s0=NULL, verbose = TRUE, filtering = FALSE)
}
\arguments{
  \item{xin}{ Either an expression set (\code{ExpressionSet}) or a data matrix with rows corresponding to features and columns corresponding to samples. }
  \item{yin}{ A numerical vector containing class labels. The higher label denotes the case, the lower label the control samples to test case vs. control. For correlation scores, \code{yin} can be any numerical vector of length equal to the number of samples. }
  \item{method}{ Character string: \code{"fc"} for fold change equivalent test (that is log ratio test), \code{"t"} for t-test, and \code{"z"} for Z-test. With \code{"pearson"} or \code{"spearman"}, the test statistic is either Pearson's correlation coefficient or Spearman's rank correlation coefficient.}
  \item{paired}{ Logical value. Depends on whether the samples are paired. Ignored if \code{method="pearson"} or \code{method="spearman"}.}
  \item{B}{ Numerical value specifying the number of permutations. }
  \item{yperm}{ Optional matrix containing in each row a permutation of the class labels in binary(!) format for two-sample testing. For computation of correlation scores, the rows of \code{yperm} have to contain the appropriate values or ranks. Use this argument carefully! If \code{yperm} is specified, no other permutation will be done. Please note that the first row of \code{yperm} MUST be the input vector \code{yin}. Otherwise, the \eqn{p}-value calculation will be incorrect.}
  \item{balance}{ Logical value. Depends on whether balanced or unbalanced permutations should be done. Ignored if \code{method="pearson"} or \code{method="spearman"}.}
  \item{quant.ci}{ Probability value for confidence lines. Lines are symmetric and denote the \code{quant.ci}-quantile of maximal absolute differences between each permutatin and the expected scores. }
  \item{s0}{ Fudge factor for variance correction in the Z-test. Takes effect only if \code{method="z"}. If \code{s0=NULL}: The fudge factor is set to the median of the pooled standard deviations.}
  \item{verbose}{ Logical value for message printing. }
  \item{filtering}{ Logical value for filtering for permutations of class labels that produce a set of complete null scores. Invokes function \code{twilight.filtering}. If \code{yperm} is specified, no filtering will be done. Note that the filtering is done on unbalanced permutations even if \code{balance=TRUE}. }
}
\details{
Please see vignette for detailed information.
}
\value{
Returns a \code{twilight} object consisting of a \code{data.frame} named \code{result} with variables
  \item{observed}{Observed test statistics.}
  \item{expected}{Mean of order statistics of the permutation statistics.}
  \item{candidate}{Binary vector. \code{"1"} for observations exceeding the confidence lines.}
  \item{pvalue}{Empirical \eqn{p}-values from two-sided hypothesis tests.}
  \item{qvalue}{\eqn{q}-values computed as described in Storey and Tibshirani (2003).}
  \item{index}{Index of the original ordering.}
Values are sorted by absolute \code{observed} scores.
}
\note{
Additional output consists of

\tabular{ll}{
  \code{ci.line} \tab Quantile corresponding to \code{quant.ci}, passed for plotting. \cr
  \code{pi0} \tab Estimated prior probability. \cr
  \code{s0} \tab Estimated fudge factor if \code{method="z"}. \cr
  \code{call} \tab Character string of function arguments. \cr
  \code{quant.ci} \tab Passes \code{quant.ci} for plotting. \cr
}

The remaining slots are left empty for function \code{twilight}.
}
\references{
Scheid S and Spang R (2004): A stochastic downhill search algorithm for estimating the local false discovery rate, \emph{IEEE TCBB} \bold{1(3)}, 98--108.

Scheid S and Spang R (2005): twilight; a Bioconductor package for estimating the local false discovery rate, \emph{Bioinformatics} \bold{21(12)}, 2921--2922. 

Scheid S and Spang R (2006): Permutation filtering: A novel concept for significance analysis of large-scale genomic data, in: Apostolico A, Guerra C, Istrail S, Pevzner P, and Waterman M (Eds.): \emph{Research in Computational Molecular Biology: 10th Annual International Conference, Proceedings of RECOMB 2006, Venice, Italy, April 2-5, 2006}. Lecture Notes in Computer Science vol. 3909, Springer, Heidelberg, pp. 338-347.

Storey JD and Tibshirani R (2003): Statistical significance for genomewide studies, \emph{PNAS} \bold{100(16)}, 9440--9445.

Tusher VG, Tibshirani R and Chu G (2001): Significance analysis of mircroarrays applied to the ionizing response, \emph{PNAS} \bold{98(9)}, 5116--5121.
}
\author{ Stefanie Scheid }
\seealso{ \code{\link{twilight}}, \code{\link{plot.twilight}}, \code{\link{twilight.combi}}, \code{\link{twilight.filtering}}, \code{\link{expval}}, \code{\link{twilight.teststat}} }

\examples{
### twilight object created from Golub data set
data(expval)
print(expval)
plot(expval)
}
\keyword{ nonparametric }

\name{twilight.getmatrix}
\alias{twilight.getmatrix}
\title{ Internal function to extract the gene expression matrix from an expression set }
\description{If the input object is of class \code{ExpressionSet}, the function extracts the gene expression matrix.}
\usage{
twilight.getmatrix(xin)
}
\arguments{
  \item{xin}{Input object of class \code{ExpressionSet}.}
}
\value{Returns the matrix of gene expression values.}
\references{
Scheid S and Spang R (2004): A stochastic downhill search algorithm for estimating the local false discovery rate, \emph{IEEE TCBB} \bold{1(3)}, 98--108.

Scheid S and Spang R (2005): twilight; a Bioconductor package for estimating the local false discovery rate, \emph{Bioinformatics} \bold{21(12)}, 2921--2922. 

Scheid S and Spang R (2006): Permutation filtering: A novel concept for significance analysis of large-scale genomic data, in: Apostolico A, Guerra C, Istrail S, Pevzner P, and Waterman M (Eds.): \emph{Research in Computational Molecular Biology: 10th Annual International Conference, Proceedings of RECOMB 2006, Venice, Italy, April 2-5, 2006}. Lecture Notes in Computer Science vol. 3909, Springer, Heidelberg, pp. 338-347.
}
\author{ Stefanie Scheid }
\seealso{ \code{\link{twilight.pval}} }
\keyword{ internal }

\name{exfdr}
\alias{exfdr}
\title{ Example of twilight result }
\docType{data}
\description{
Application of function \code{twilight} on twilight object \code{data(expval)}.

The function call was \code{exfdr <- twilight(expval,B=1000)}.
}
\usage{data(exfdr)}
\format{A twilight object.}
\references{
Scheid S and Spang R (2004): A stochastic downhill search algorithm for estimating the local false discovery rate, \emph{IEEE TCBB} \bold{1(3)}, 98--108.

Scheid S and Spang R (2005): twilight; a Bioconductor package for estimating the local false discovery rate, \emph{Bioinformatics} \bold{21(12)}, 2921--2922. 

Scheid S and Spang R (2006): Permutation filtering: A novel concept for significance analysis of large-scale genomic data, in: Apostolico A, Guerra C, Istrail S, Pevzner P, and Waterman M (Eds.): \emph{Research in Computational Molecular Biology: 10th Annual International Conference, Proceedings of RECOMB 2006, Venice, Italy, April 2-5, 2006}. Lecture Notes in Computer Science vol. 3909, Springer, Heidelberg, pp. 338-347.
}
\keyword{datasets}
